//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%46D84E6B0285.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%46D84E6B0285.cm

//## begin module%46D84E6B0285.cp preserve=no
//## end module%46D84E6B0285.cp

//## Module: ChainIO%46D84E6B0285; Package specification
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/MCMC/ChainIO.h

#ifndef CHAINIO_H
#define CHAINIO_H 1

//## begin module%46D84E6B0285.additionalIncludes preserve=no
//## end module%46D84E6B0285.additionalIncludes

//## begin module%46D84E6B0285.includes preserve=yes
//## end module%46D84E6B0285.includes

// Error
#include <XSUtil/Error/Error.h>
//## begin module%46D84E6B0285.declarations preserve=no
//## end module%46D84E6B0285.declarations

//## begin module%46D84E6B0285.additionalDeclarations preserve=yes
class Chain;

#include <xsTypes.h>
//## end module%46D84E6B0285.additionalDeclarations


//## begin ChainIO%46D851110272.preface preserve=yes
//## end ChainIO%46D851110272.preface

//## Class: ChainIO%46D851110272
//## Category: XSFit::MCMC%41E6AB1C02FC
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class ChainIO 
{
  //## begin ChainIO%46D851110272.initialDeclarations preserve=yes
  //## end ChainIO%46D851110272.initialDeclarations

  public:
    //## Class: ChainIOError%46DD734C00AC
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ChainIOError : public YellowAlert  //## Inherits: <unnamed>%46DD738A00DE
    {
      public:
        //## Constructors (specified)
          //## Operation: ChainIOError%46DD73F40356
          ChainIOError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~ChainIO();


    //## Other Operations (specified)
      //## Operation: doOpenForReadPoints%46D85A570003
      virtual void doOpenForReadPoints () const = 0;

      //## Operation: doCloseFile%46D85AD202D7
      virtual void doCloseFile () const = 0;

      //## Operation: doOpenForWrite%46DF24000051
      virtual void doOpenForWrite () = 0;

      //## Operation: doReadPoint%46D85AF10393
      virtual void doReadPoint (std::vector<Real>& chainVals) const = 0;

      //## Operation: doReadPointFromLine%46D85B3F00E1
      virtual void doReadPointFromLine (size_t lineNum, RealArray& parVals) const = 0;

      //## Operation: getFormatName%46DDBE6E013C
      virtual const string& getFormatName () const = 0;

      //## Operation: readFileInfo%46D873C60059
      virtual void readFileInfo ();

      //## Operation: createFile%46DD67090064
      virtual void createFile ();

      //## Operation: writePoint%46DD6747033F
      virtual void writePoint ();

      //## Operation: writeFileInfo%46DD69880219
      virtual void writeFileInfo ();

      //## Operation: adjustLengthInfo%46DD69A6035F
      virtual void adjustLengthInfo ();

      //## Operation: appendFile%46DD6A0A037C
      virtual void appendFile (RealArray& startingVals);

      //## Operation: adjustTemperInfo%46DD71FE0007
      virtual void adjustTemperInfo ();

      //## Operation: checkTemperField%46DD721D006D
      virtual bool checkTemperField (const Real temperature) const;

      //## Operation: setParent%46DDB33500ED
      virtual void setParent (Chain* chain);

      //## Operation: allowsTemper%46DF28790113
      virtual bool allowsTemper () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: TEMPERPREC%46DD772B0074
      static const int& TEMPERPREC ();

      //## Attribute: FWIDTH%46DD91D601FA
      static const int FWIDTH ();

  public:
    // Additional Public Declarations
      //## begin ChainIO%46D851110272.public preserve=yes
      //## end ChainIO%46D851110272.public

  protected:
    //## Constructors (generated)
      ChainIO();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: LENGTHLABEL%46DD7648014D
      static const string& LENGTHLABEL ();

      //## Attribute: WIDTHLABEL%46DD76DB0340
      static const string& WIDTHLABEL ();

      //## Attribute: PRECISION%46DD76E703D3
      static const int& PRECISION ();

      //## Attribute: TEMPERLABEL%46DD76F000CD
      static const string& TEMPERLABEL ();

    // Additional Protected Declarations
      //## begin ChainIO%46D851110272.protected preserve=yes
      //## end ChainIO%46D851110272.protected

  private:
    //## Constructors (generated)
      ChainIO(const ChainIO &right);

    //## Assignment Operation (generated)
      ChainIO & operator=(const ChainIO &right);

    // Additional Private Declarations
      //## begin ChainIO%46D851110272.private preserve=yes
      //## end ChainIO%46D851110272.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin ChainIO::LENGTHLABEL%46DD7648014D.attr preserve=no  protected: static const string {U} string("Length")
      static const string s_LENGTHLABEL;
      //## end ChainIO::LENGTHLABEL%46DD7648014D.attr

      //## begin ChainIO::WIDTHLABEL%46DD76DB0340.attr preserve=no  protected: static const string {U} string("Width")
      static const string s_WIDTHLABEL;
      //## end ChainIO::WIDTHLABEL%46DD76DB0340.attr

      //## begin ChainIO::PRECISION%46DD76E703D3.attr preserve=no  protected: static const int {U} 14
      static const int s_PRECISION;
      //## end ChainIO::PRECISION%46DD76E703D3.attr

      //## begin ChainIO::TEMPERLABEL%46DD76F000CD.attr preserve=no  protected: static const string {U} string("Tempering")
      static const string s_TEMPERLABEL;
      //## end ChainIO::TEMPERLABEL%46DD76F000CD.attr

      //## begin ChainIO::TEMPERPREC%46DD772B0074.attr preserve=no  public: static const int {U} 4
      static const int s_TEMPERPREC;
      //## end ChainIO::TEMPERPREC%46DD772B0074.attr

      //## begin ChainIO::FWIDTH%46DD91D601FA.attr preserve=no  public: static const int {U} s_PRECISION + 7
      static const int s_FWIDTH;
      //## end ChainIO::FWIDTH%46DD91D601FA.attr

    // Additional Implementation Declarations
      //## begin ChainIO%46D851110272.implementation preserve=yes
      //## end ChainIO%46D851110272.implementation

};

//## begin ChainIO%46D851110272.postscript preserve=yes
//## end ChainIO%46D851110272.postscript

// Class ChainIO::ChainIOError 

// Class ChainIO 

inline ChainIO::ChainIO()
  //## begin ChainIO::ChainIO%46D851110272_const.hasinit preserve=no
  //## end ChainIO::ChainIO%46D851110272_const.hasinit
  //## begin ChainIO::ChainIO%46D851110272_const.initialization preserve=yes
  //## end ChainIO::ChainIO%46D851110272_const.initialization
{
  //## begin ChainIO::ChainIO%46D851110272_const.body preserve=yes
  //## end ChainIO::ChainIO%46D851110272_const.body
}


inline ChainIO::~ChainIO()
{
  //## begin ChainIO::~ChainIO%46D851110272_dest.body preserve=yes
  //## end ChainIO::~ChainIO%46D851110272_dest.body
}


//## Get and Set Operations for Class Attributes (inline)

inline const string& ChainIO::LENGTHLABEL ()
{
  //## begin ChainIO::LENGTHLABEL%46DD7648014D.get preserve=no
  return s_LENGTHLABEL;
  //## end ChainIO::LENGTHLABEL%46DD7648014D.get
}

inline const string& ChainIO::WIDTHLABEL ()
{
  //## begin ChainIO::WIDTHLABEL%46DD76DB0340.get preserve=no
  return s_WIDTHLABEL;
  //## end ChainIO::WIDTHLABEL%46DD76DB0340.get
}

inline const int& ChainIO::PRECISION ()
{
  //## begin ChainIO::PRECISION%46DD76E703D3.get preserve=no
  return s_PRECISION;
  //## end ChainIO::PRECISION%46DD76E703D3.get
}

inline const string& ChainIO::TEMPERLABEL ()
{
  //## begin ChainIO::TEMPERLABEL%46DD76F000CD.get preserve=no
  return s_TEMPERLABEL;
  //## end ChainIO::TEMPERLABEL%46DD76F000CD.get
}

inline const int& ChainIO::TEMPERPREC ()
{
  //## begin ChainIO::TEMPERPREC%46DD772B0074.get preserve=no
  return s_TEMPERPREC;
  //## end ChainIO::TEMPERPREC%46DD772B0074.get
}

inline const int ChainIO::FWIDTH ()
{
  //## begin ChainIO::FWIDTH%46DD91D601FA.get preserve=no
  return s_FWIDTH;
  //## end ChainIO::FWIDTH%46DD91D601FA.get
}

//## begin module%46D84E6B0285.epilog preserve=yes
//## end module%46D84E6B0285.epilog


#endif
